
#include "ringBuffer.h"

/*
  // testy ringBufferu:
  RingBuffer* rb = new RingBuffer(10);
  for( int i = 0; i<22; i++ )
  {
      logger->log( "vkladam: %d", i );
      rb->put(i);
      rb->printStat( logger ); 
      rb->dumpContent( logger, 10 );
  }
 */

RingBuffer::RingBuffer( int size )
{
    this->data = new int[size];
    this->max = size;
    this->size = 0;
    this->pos = 0;
}

void RingBuffer::put( int val )
{
   this->data[ this->pos ]=val;
   if( this->size < this->max ) {
      this->size++;
   }
   this->pos++;
   if( this->pos == this->max ) {
      this->pos = 0;
   }
}

int RingBuffer::get( int offset )
{
    if( this->size==0 || offset >= this->size ) return RB_NODATA;

    int getPos = this->pos - 1 - offset;
    if( getPos<0 ) {
       getPos = getPos + this->max;
    }
    return this->data[getPos];
}

void RingBuffer::printStat( raLogger * logger )
{
    char buffer[500];
    buffer[0] = 0;
    int offset = 0;
    for( int i = 0; (i<this->size) && (i<50); i++ ) {
        offset += sprintf( buffer+offset,
            "%s%d%s ",
            ( i==this->pos ? ">" : "" ),
            this->data[i],
            ( i==(this->size-1) ? ")" : "" )
        );
    }
    logger->log( "RB: size=%d pos=%d max=%d [ %s]", this->size, this->pos, this->max, buffer );
}

void RingBuffer::dumpContent( raLogger * logger, int count )
{
    char buffer[500];
    buffer[0] = 0;
    int offset = 0;

    if( count>50 ) count=50;

    for( int i = 0; (i<this->size) && (i<count); i++ ) {
        offset += sprintf( buffer+offset,
            "%d ",
            this->get(i)
        );
    }
    logger->log( "RB: %d [ %s]", this->size, buffer );
}
