
#ifndef RINGBUFFER_H
#define RINGBUFFER_H

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <Arduino.h>
#include "src/ra/raLogger.h"

#define RB_NODATA -999999999


class RingBuffer
{
  public:
    
    RingBuffer( int count );
    void put( int value );
    int get( int offset );  // 0 = current, 1 = prev, 
    int size;
    
    void printStat( raLogger * logger );
    void dumpContent( raLogger * logger, int count );

  private:
    int* data;
    int pos;
    int max;
};

#endif   // RINGBUFFER_H
